Index: trunk/src/user32/user32.cpp
===================================================================
--- trunk/src/user32/user32.cpp	(revision 1514)
+++ trunk/src/user32/user32.cpp	(revision 1516)
@@ -1,3 +1,3 @@
-/* $Id: user32.cpp,v 1.48 1999-10-28 18:22:28 sandervl Exp $ */
+/* $Id: user32.cpp,v 1.49 1999-10-30 10:55:15 sandervl Exp $ */
 
 /*
@@ -2244,16 +2244,4 @@
 }
 
-/* Dialog Box Functions */
-
-BOOL WIN32API MapDialogRect( HWND hDlg, PRECT  lpRect)
-{
-#ifdef DEBUG
-    WriteLog("USER32:  MapDialogRect\n");
-#endif
-    hDlg = Win32Window::Win32ToOS2Handle(hDlg);
-
-    return O32_MapDialogRect(hDlg,lpRect);
-}
-
 /* Icon Functions */
 int WIN32API LookupIconIdFromDirectory(PBYTE presbits, BOOL fIcon)
Index: trunk/src/user32/win32dlg.cpp
===================================================================
--- trunk/src/user32/win32dlg.cpp	(revision 1514)
+++ trunk/src/user32/win32dlg.cpp	(revision 1516)
@@ -1,3 +1,3 @@
-/* $Id: win32dlg.cpp,v 1.22 1999-10-30 09:19:45 sandervl Exp $ */
+/* $Id: win32dlg.cpp,v 1.23 1999-10-30 10:55:15 sandervl Exp $ */
 /*
  * Win32 Dialog Code for OS/2
@@ -236,4 +236,14 @@
     dprintf(("********* DIALOG CREATION FAILED! ************"));
     return FALSE;
+}
+//******************************************************************************
+//******************************************************************************
+BOOL Win32Dialog::MapDialogRect(LPRECT rect)
+{
+    rect->left   = (rect->left * xUnit) / 4;
+    rect->right  = (rect->right * xUnit) / 4;
+    rect->top    = (rect->top * yUnit) / 8;
+    rect->bottom = (rect->bottom * yUnit) / 8;
+    return TRUE;
 }
 /***********************************************************************
Index: trunk/src/user32/win32dlg.h
===================================================================
--- trunk/src/user32/win32dlg.h	(revision 1514)
+++ trunk/src/user32/win32dlg.h	(revision 1516)
@@ -1,3 +1,3 @@
-/* $Id: win32dlg.h,v 1.4 1999-10-17 20:18:45 sandervl Exp $ */
+/* $Id: win32dlg.h,v 1.5 1999-10-30 10:55:16 sandervl Exp $ */
 /*
  * Win32 Dialog Code for OS/2
@@ -73,4 +73,6 @@
          BOOL   endDialog(int retval);
 
+         BOOL   MapDialogRect(LPRECT rect);
+
 virtual  ULONG  MsgCreate(HWND hwndFrame, HWND hwndClient);
 
Index: trunk/src/user32/windlg.cpp
===================================================================
--- trunk/src/user32/windlg.cpp	(revision 1514)
+++ trunk/src/user32/windlg.cpp	(revision 1516)
@@ -1,3 +1,3 @@
-/* $Id: windlg.cpp,v 1.7 1999-10-17 20:18:46 sandervl Exp $ */
+/* $Id: windlg.cpp,v 1.8 1999-10-30 10:55:16 sandervl Exp $ */
 /*
  * Win32 dialog apis for OS/2
@@ -197,4 +197,20 @@
     return -1;
 }
+/***********************************************************************
+ *           MapDialogRect32   (USER32.382)
+ */
+BOOL WIN32API MapDialogRect(HWND hwndDlg, LPRECT rect)
+{
+  Win32Dialog *dialog;
+
+    dialog = (Win32Dialog *)Win32BaseWindow::GetWindowFromHandle(hwndDlg);
+    if(!dialog || !dialog->IsDialog()) {
+        dprintf(("MapDialogRect, window %x not found", hwndDlg));
+        SetLastError(ERROR_INVALID_WINDOW_HANDLE);
+        return 0;
+    }
+    dprintf(("USER32: MapDialogRect\n"));
+    return dialog->MapDialogRect(rect);
+}
 //******************************************************************************
 //******************************************************************************
Index: trunk/src/user32/window.cpp
===================================================================
--- trunk/src/user32/window.cpp	(revision 1514)
+++ trunk/src/user32/window.cpp	(revision 1516)
@@ -1,3 +1,3 @@
-/* $Id: window.cpp,v 1.27 1999-10-30 09:19:47 sandervl Exp $ */
+/* $Id: window.cpp,v 1.28 1999-10-30 10:55:16 sandervl Exp $ */
 /*
  * Win32 window apis for OS/2
@@ -181,4 +181,8 @@
         }
     }
+    if(HIWORD(className)) {
+         dprintf(("CreateWindowExW: class %s parent %x (%d,%d) (%d,%d), %x %x", className, parent, x, y, width, height, style, exStyle));
+    }
+    else dprintf(("CreateWindowExW: class %d parent %x (%d,%d) (%d,%d), %x %x", className, parent, x, y, width, height, style, exStyle));
 
     /* Create the window */