Index: trunk/src/user32/pmframe.cpp
===================================================================
--- trunk/src/user32/pmframe.cpp	(revision 1540)
+++ trunk/src/user32/pmframe.cpp	(revision 1542)
@@ -1,3 +1,3 @@
-/* $Id: pmframe.cpp,v 1.16 1999-11-01 19:11:41 sandervl Exp $ */
+/* $Id: pmframe.cpp,v 1.17 1999-11-02 17:07:25 cbratschi Exp $ */
 /*
  * Win32 Frame Managment Code for OS/2
@@ -245,4 +245,5 @@
 
         if(!win32wnd->CanReceiveSizeMsgs()) {
+            goto RunDefFrameProc; //CB: must call def frame proc or frame control activation is broken
             break;
         }
@@ -267,8 +268,11 @@
            if(wndAfter) wp.hwndInsertAfter = wndAfter->getWindowHandle();
         }
+
+        //CB: problems with profmine titlebar tracking
         if(win32wnd->MsgPosChanging((LPARAM)&wp) == 0)
         {//app or default window handler changed wp
             dprintf(("PMFRAME: WM_ADJUSTWINDOWPOS, app changed windowpos struct"));
             dprintf(("%x (%d,%d), (%d,%d)", pswp->fl, pswp->x, pswp->y, pswp->cx, pswp->cy));
+
             OSLibMapWINDOWPOStoSWPFrame(&wp, pswp, &swpOld, hParent, hwnd);
             dprintf(("%x (%d,%d), (%d,%d)", pswp->fl, pswp->x, pswp->y, pswp->cx, pswp->cy));
@@ -277,6 +281,7 @@
             pswp->hwnd = hwnd;
 
-            RestoreOS2TIB();
-            return (MRESULT)0xf;
+            goto RunDefFrameProc; //CB: must call def frame proc or frame control activation is broken
+            //RestoreOS2TIB();
+            //return (MRESULT)0xf;
         }
         goto RunDefFrameProc; //CB: must call def frame proc or frame control activation is broken
Index: trunk/src/user32/win32dlg.cpp
===================================================================
--- trunk/src/user32/win32dlg.cpp	(revision 1540)
+++ trunk/src/user32/win32dlg.cpp	(revision 1542)
@@ -1,3 +1,3 @@
-/* $Id: win32dlg.cpp,v 1.26 1999-10-31 01:14:42 sandervl Exp $ */
+/* $Id: win32dlg.cpp,v 1.27 1999-11-02 17:07:25 cbratschi Exp $ */
 /*
  * Win32 Dialog Code for OS/2
@@ -19,4 +19,5 @@
 #include <win32dlg.h>
 #include "oslibmsg.h"
+#include "oslibwin.h"
 #include "win32wdesktop.h"
 #include "controls.h"
@@ -270,4 +271,6 @@
     {
         topOwner->EnableWindow( FALSE );
+        //CB: todo: make modal, implement modeless, remove FCF_TASKLIST
+        //    emulate WinProcessDlg
         ShowWindow( SW_SHOW );
 
Index: trunk/src/user32/win32wbase.cpp
===================================================================
--- trunk/src/user32/win32wbase.cpp	(revision 1540)
+++ trunk/src/user32/win32wbase.cpp	(revision 1542)
@@ -1,3 +1,3 @@
-/* $Id: win32wbase.cpp,v 1.71 1999-11-01 19:11:43 sandervl Exp $ */
+/* $Id: win32wbase.cpp,v 1.72 1999-11-02 17:07:25 cbratschi Exp $ */
 /*
  * Win32 Window Base Class for OS/2
@@ -1601,5 +1601,5 @@
     case WM_SETTEXT:
     {
-        if(!fInternalMsg) 
+        if(!fInternalMsg)
         {
            LRESULT result;
@@ -2422,5 +2422,5 @@
 HWND Win32BaseWindow::SetActiveWindow()
 {
-  return OSLibWinSetActiveWindow(OS2Hwnd);
+  return OSLibWinSetActiveWindow(OS2HwndFrame);
 }
 //******************************************************************************
@@ -2429,5 +2429,5 @@
 BOOL Win32BaseWindow::EnableWindow(BOOL fEnable)
 {
-  return OSLibWinEnableWindow(OS2Hwnd, fEnable);
+  return OSLibWinEnableWindow(OS2HwndFrame, fEnable);
 }
 //******************************************************************************
@@ -2435,5 +2435,5 @@
 BOOL Win32BaseWindow::CloseWindow()
 {
-  return OSLibWinMinimizeWindow(OS2Hwnd);
+  return OSLibWinMinimizeWindow(OS2HwndFrame);
 }
 //******************************************************************************
@@ -2459,5 +2459,5 @@
 BOOL Win32BaseWindow::IsWindowEnabled()
 {
-    return OSLibWinIsWindowEnabled(OS2Hwnd);
+    return OSLibWinIsWindowEnabled(OS2HwndFrame);
 }
 //******************************************************************************
@@ -2468,5 +2468,5 @@
     return (dwStyle & WS_VISIBLE) == WS_VISIBLE;
 #else
-    return OSLibWinIsWindowVisible(OS2Hwnd);
+    return OSLibWinIsWindowVisible(OS2HwndFrame);
 #endif
 }