Index: trunk/src/shell32/classes.cpp
===================================================================
--- trunk/src/shell32/classes.cpp	(revision 1542)
+++ trunk/src/shell32/classes.cpp	(revision 1543)
@@ -1,3 +1,3 @@
-/* $Id: classes.cpp,v 1.1 1999-10-09 11:13:18 sandervl Exp $ */
+/* $Id: classes.cpp,v 1.2 1999-11-02 18:50:15 phaller Exp $ */
 
 /*
@@ -54,5 +54,5 @@
  *****************************************************************************/
 
-BOOL HCR_MapTypeToValue ( LPCSTR szExtension, LPSTR szFileType, LONG len, BOOL bPrependDot)
+BOOL HCR_MapTypeToValue ( LPCSTR szExtension, LPSTR szFileType, DWORD len, BOOL bPrependDot)
 {
         HKEY    hkey;
@@ -74,5 +74,5 @@
         }
 
-        if (RegQueryValueA(hkey,NULL,szFileType,&len))
+        if (RegQueryValueA(hkey,NULL,szFileType,(LPLONG)&len))
         { RegCloseKey(hkey);
           return FALSE;
@@ -86,6 +86,5 @@
 }
 
-
-BOOL HCR_GetExecuteCommand ( LPCSTR szClass, LPCSTR szVerb, LPSTR szDest, LONG len )
+BOOL HCR_GetExecuteCommand ( LPCSTR szClass, LPCSTR szVerb, LPSTR szDest, DWORD len )
 {
         HKEY    hkey;
@@ -104,5 +103,5 @@
         }
 
-        if (RegQueryValueA(hkey,NULL,szDest,&len))
+        if (RegQueryValueA(hkey,NULL,szDest,(LPLONG)&len))
         { RegCloseKey(hkey);
           return FALSE;
@@ -120,5 +119,5 @@
 * Gets the icon for a filetype
 */
-BOOL HCR_GetDefaultIcon (LPCSTR szClass, LPSTR szDest, LONG len, LPDWORD dwNr)
+BOOL HCR_GetDefaultIcon (LPCSTR szClass, LPSTR szDest, DWORD len, LPDWORD dwNr)
 {
         HKEY    hkey;
@@ -138,5 +137,5 @@
         }
 
-        if (RegQueryValueA(hkey,NULL,szDest,&len))
+        if (RegQueryValueA(hkey,NULL,szDest,(LPLONG)&len))
         { RegCloseKey(hkey);
           return FALSE;
Index: trunk/src/shell32/pidl.h
===================================================================
--- trunk/src/shell32/pidl.h	(revision 1542)
+++ trunk/src/shell32/pidl.h	(revision 1543)
@@ -1,3 +1,3 @@
-/* $Id: pidl.h,v 1.1 1999-10-09 11:13:20 sandervl Exp $ */
+/* $Id: pidl.h,v 1.2 1999-11-02 18:50:15 phaller Exp $ */
 
 /*
@@ -45,4 +45,6 @@
 *	----------------------------------------------------------------
 *	my computer	0x1F/20		mycomp (2)	(usual)
+*	network		0x1F		mycomp
+*	bitbucket	0x1F		mycomp
 *	drive		0x23/25		drive		(usual)
 *	drive		0x25/25		drive		(lnk/persistant)
@@ -128,59 +130,57 @@
 
 /*
- * getting string values from pidls
- *
- * return value is strlen()
- */
-DWORD WINAPI _ILGetDrive(LPCITEMIDLIST,LPSTR,UINT16);
-/*
-DWORD WINAPI _ILGetItemText(LPCITEMIDLIST,LPSTR,UINT16);
-DWORD WINAPI _ILGetFolderText(LPCITEMIDLIST,LPSTR,DWORD);
-DWORD WINAPI _ILGetValueText(LPCITEMIDLIST,LPSTR,DWORD);
-DWORD WINAPI _ILGetPidlPath(LPCITEMIDLIST,LPSTR,DWORD);
-*/
-
-/*
  * getting special values from simple pidls
  */
-BOOL WINAPI _ILGetFileDate (LPCITEMIDLIST pidl, LPSTR pOut, UINT uOutSize);
-BOOL WINAPI _ILGetFileSize (LPCITEMIDLIST pidl, LPSTR pOut, UINT uOutSize);
-BOOL WINAPI _ILGetExtension (LPCITEMIDLIST pidl, LPSTR pOut, UINT uOutSize);
+DWORD	WINAPI _ILSimpleGetText	(LPCITEMIDLIST pidl, LPSTR pOut, UINT uOutSize);
+BOOL	WINAPI _ILGetFileDate 		(LPCITEMIDLIST pidl, LPSTR pOut, UINT uOutSize);
+DWORD	WINAPI _ILGetFileSize		(LPCITEMIDLIST pidl, LPSTR pOut, UINT uOutSize);
+BOOL	WINAPI _ILGetExtension		(LPCITEMIDLIST pidl, LPSTR pOut, UINT uOutSize);
+void	WINAPI _ILGetFileType		(LPCITEMIDLIST pidl, LPSTR pOut, UINT uOutSize);
+BOOL	WINAPI _ILGetAttributeStr	(LPCITEMIDLIST pidl, LPSTR pOut, UINT uOutSize);
 
+BOOL	WINAPI _ILGetFileDateTime	(LPCITEMIDLIST pidl, FILETIME *ft);
+DWORD	WINAPI _ILGetDrive		(LPCITEMIDLIST, LPSTR, UINT16);
 
 /*
  * testing simple pidls
  */
-BOOL WINAPI _ILIsDesktop(LPCITEMIDLIST);
-BOOL WINAPI _ILIsMyComputer(LPCITEMIDLIST);
-BOOL WINAPI _ILIsDrive(LPCITEMIDLIST);
-BOOL WINAPI _ILIsFolder(LPCITEMIDLIST);
-BOOL WINAPI _ILIsValue(LPCITEMIDLIST);
-BOOL WINAPI _ILIsSpecialFolder (LPCITEMIDLIST pidl);
-BOOL WINAPI _ILIsPidlSimple ( LPCITEMIDLIST pidl);
+BOOL	WINAPI _ILIsDesktop		(LPCITEMIDLIST pidl);
+BOOL	WINAPI _ILIsMyComputer		(LPCITEMIDLIST pidl);
+BOOL	WINAPI _ILIsDrive		(LPCITEMIDLIST pidl);
+BOOL	WINAPI _ILIsFolder		(LPCITEMIDLIST pidl);
+BOOL	WINAPI _ILIsValue		(LPCITEMIDLIST pidl);
+BOOL	WINAPI _ILIsSpecialFolder	(LPCITEMIDLIST pidl);
+BOOL	WINAPI _ILIsPidlSimple		(LPCITEMIDLIST pidl);
 
 /*
  * simple pidls from strings
  */
-LPITEMIDLIST WINAPI _ILCreateDesktop(void);
-LPITEMIDLIST WINAPI _ILCreateMyComputer(void);
-LPITEMIDLIST WINAPI _ILCreateIExplore(void);
-LPITEMIDLIST WINAPI _ILCreateDrive(LPCSTR);
-LPITEMIDLIST WINAPI _ILCreateFolder(WIN32_FIND_DATAA * stffile);
-LPITEMIDLIST WINAPI _ILCreateValue(WIN32_FIND_DATAA * stffile);
-LPITEMIDLIST WINAPI _ILCreateSpecial(LPCSTR szGUID);
+LPITEMIDLIST	WINAPI _ILCreate	(PIDLTYPE,LPCVOID,UINT16);
 
-DWORD WINAPI _ILSimpleGetText (LPCITEMIDLIST pidl, LPSTR szOut, UINT uOutSize);
-
-LPITEMIDLIST WINAPI _ILCreate(PIDLTYPE,LPCVOID,UINT16);
+LPITEMIDLIST	WINAPI _ILCreateDesktop		(void);
+LPITEMIDLIST	WINAPI _ILCreateMyComputer	(void);
+LPITEMIDLIST	WINAPI _ILCreateIExplore	(void);
+LPITEMIDLIST	WINAPI _ILCreateControl		(void);
+LPITEMIDLIST	WINAPI _ILCreatePrinter		(void);
+LPITEMIDLIST	WINAPI _ILCreateNetwork		(void);
+LPITEMIDLIST	WINAPI _ILCreateBitBucket	(void);
+LPITEMIDLIST	WINAPI _ILCreateDrive		(LPCSTR);
+LPITEMIDLIST	WINAPI _ILCreateFolder		(WIN32_FIND_DATAA * stffile);
+LPITEMIDLIST	WINAPI _ILCreateValue		(WIN32_FIND_DATAA * stffile);
+LPITEMIDLIST	WINAPI _ILCreateSpecial		(LPCSTR szGUID);
 
 /*
  * helper functions (getting struct-pointer)
  */
-LPPIDLDATA WINAPI _ILGetDataPointer(LPCITEMIDLIST);
-LPSTR WINAPI _ILGetTextPointer(PIDLTYPE type, LPPIDLDATA pidldata);
-LPSTR WINAPI _ILGetSTextPointer(PIDLTYPE type, LPPIDLDATA pidldata);
-REFIID WINAPI _ILGetGUIDPointer(LPCITEMIDLIST pidl);
+LPPIDLDATA	WINAPI _ILGetDataPointer	(LPCITEMIDLIST);
+LPSTR		WINAPI _ILGetTextPointer	(PIDLTYPE type, LPPIDLDATA pidldata);
+LPSTR		WINAPI _ILGetSTextPointer	(PIDLTYPE type, LPPIDLDATA pidldata);
+REFIID		WINAPI _ILGetGUIDPointer	(LPCITEMIDLIST pidl);
 
+/* 
+ * debug helper 
+ */
 void pdump (LPCITEMIDLIST pidl);
 BOOL pcheck (LPCITEMIDLIST pidl);
+
 #endif
Index: trunk/src/shell32/resource.asm
===================================================================
--- trunk/src/shell32/resource.asm	(revision 1542)
+++ trunk/src/shell32/resource.asm	(revision 1543)
@@ -2,5 +2,5 @@
 ;/* Source : shres.rc */
 ;/* Cmdline: wrc -s -I. -ID:\IBMCPP\include -I..\..\include -I..\..\include\win -o resource.asm shres.rc */
-;/* Date   : Mon Oct 25 10:23:09 1999 */
+;/* Date   : Thu Oct 28 13:10:07 1999 */
 
 	.386p
@@ -12,5 +12,5 @@
 	public	_Resource_PEResTab
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 6
@@ -29,5 +29,5 @@
 L3:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 16
@@ -66,5 +66,5 @@
 L4:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	3, 0
@@ -77,5 +77,5 @@
 L5:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	2, 0
@@ -86,5 +86,5 @@
 L6:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 2
@@ -95,5 +95,5 @@
 L14:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 5
@@ -110,5 +110,5 @@
 L16:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -117,5 +117,5 @@
 L3_1:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -124,5 +124,5 @@
 L3_2:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -131,5 +131,5 @@
 L3_3:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -138,5 +138,5 @@
 L3_4:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -145,5 +145,5 @@
 L3_5:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -152,5 +152,5 @@
 L3_6:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -159,5 +159,5 @@
 L3_7:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -166,5 +166,5 @@
 L3_8:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -173,5 +173,5 @@
 L3_9:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -180,5 +180,5 @@
 L3_10:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -187,5 +187,5 @@
 L3_11:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -194,5 +194,5 @@
 L3_12:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -201,5 +201,5 @@
 L3_13:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -208,5 +208,5 @@
 L3_14:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -215,5 +215,5 @@
 L3_15:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -222,5 +222,5 @@
 L3_16:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -229,5 +229,5 @@
 L4_MENU_001:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -236,5 +236,5 @@
 L4_MENU_002:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -243,5 +243,5 @@
 L4_MENU_SHV_FILE:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -250,5 +250,5 @@
 L5_SHBRSFORFOLDER_MSGBOX:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -257,5 +257,5 @@
 L5_SHELL_ABOUT_MSGBOX:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -264,5 +264,5 @@
 L6_1:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -271,5 +271,5 @@
 L6_2:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -278,5 +278,5 @@
 L14_0:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -285,5 +285,5 @@
 L14_3:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -292,5 +292,5 @@
 L14_8:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -299,5 +299,5 @@
 L14_15:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -306,5 +306,5 @@
 L14_34:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
@@ -313,5 +313,5 @@
 L16_1:
 	dd	0
-	dd	03814217dh
+	dd	038183d1fh
 	dd	0
 	dw	0, 1
Index: trunk/src/shell32/shell32_main.h
===================================================================
--- trunk/src/shell32/shell32_main.h	(revision 1542)
+++ trunk/src/shell32/shell32_main.h	(revision 1543)
@@ -1,3 +1,3 @@
-/* $Id: shell32_main.h,v 1.1 1999-10-09 11:13:23 sandervl Exp $ */
+/* $Id: shell32_main.h,v 1.2 1999-11-02 18:50:16 phaller Exp $ */
 
 /*
@@ -97,7 +97,7 @@
 
 /* Classes Root */
-BOOL HCR_MapTypeToValue ( LPCSTR szExtension, LPSTR szFileType, LONG len, BOOL bPrependDot);
-BOOL HCR_GetExecuteCommand ( LPCSTR szClass, LPCSTR szVerb, LPSTR szDest, LONG len );
-BOOL HCR_GetDefaultIcon (LPCSTR szClass, LPSTR szDest, LONG len, LPDWORD dwNr);
+BOOL HCR_MapTypeToValue ( LPCSTR szExtension, LPSTR szFileType, DWORD len, BOOL bPrependDot);
+BOOL HCR_GetExecuteCommand ( LPCSTR szClass, LPCSTR szVerb, LPSTR szDest, DWORD len );
+BOOL HCR_GetDefaultIcon (LPCSTR szClass, LPSTR szDest, DWORD len, LPDWORD dwNr);
 BOOL HCR_GetClassName (REFIID riid, LPSTR szDest, DWORD len);
 BOOL HCR_GetFolderAttributes (REFIID riid, LPDWORD szDest);
Index: trunk/src/shell32/shell32exp.def
===================================================================
--- trunk/src/shell32/shell32exp.def	(revision 1542)
+++ trunk/src/shell32/shell32exp.def	(revision 1543)
@@ -1,3 +1,2 @@
-;/* $Id: shell32exp.def,v 1.2 1999-10-09 11:17:04 sandervl Exp $ */
 ;Internal export definition file - autogenerated by ImpDef.
 LIBRARY SHELL32 INITINSTANCE
@@ -148,6 +147,6 @@
     _ExtractIconExA@20                        @190
     _ExtractIconExW@20                        @191
-    _ExtractIconResInfoA@0                    @192
-    _ExtractIconResInfoW@0                    @193
+    _ExtractIconResInfoA@4                    @192
+    _ExtractIconResInfoW@4                    @193
     _ExtractIconW@12                          @194
     _SHFree@4                                 @195
@@ -157,6 +156,6 @@
     _FindExecutableW@12                       @219
     _FreeIconList@4                           @220
-    _InternalExtractIconListA@0               @221
-    _InternalExtractIconListW@0               @222
+    _InternalExtractIconListA@4               @221
+    _InternalExtractIconListW@4               @222
     _RealShellExecuteA@24                     @229
     _RealShellExecuteExA@4                    @230